//************************************************************************
//
//	DOserver.m.  
//
//	by	Felipe A. Rodriguez		
//
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import "DOserver.h"
#import "Coordinator.h"
#import "SwapView.h"
#import <appkit/nextstd.h>
#import <remote/NXProxy.h>

		// ppp editor lists
	extern char *flist[];

@implementation DOserver

//************************************************************************
//
//		show Dialer panel 
//
//************************************************************************

- showDialPanel 
{
    if(!gatePanel)
		[NXApp loadNibSection:"Inspector.nib" owner:self withNames:NO];
    [theInspector inspectName:"FirstInspector"];		// swap inspectors
	[gatePanel setFrameAutosaveName:"gataPanel"];		// remem loc/size
    [gatePanel makeKeyAndOrderFront:self];	
	[phoneNumField setStringValue:NXGetDefaultValue([NXApp appName], 	
														"lastNumDialed")];
	[phoneNumField selectText:self];
	
    return self;
}
//*****************************************************************************
//
// 		called when GateTool's mach port becomes invalid 
//
//*****************************************************************************

- senderIsInvalid:sender 
{
	if(gatePanel)
		[gatePanel close];
	if(!connecting)							// if not starting pppd, cleanup
		[delegate DOFinished];
	connecting = NO;						// pppd will be started yes/NO
	
    return self;
}
//*****************************************************************************
//
// 		send to the gatetool server the phone num to dial 
//
//*****************************************************************************

- Dial:sender  
{
char prefix[16] = {"SEND "}, dialStr[56];

	strcpy(dialStr, prefix);
	strncat(dialStr, NXGetDefaultValue([NXApp appName], "dialPrefix"), 8);
	strcat(dialStr, [phoneNumField stringValue]);
		// store last num dialed in defaults database
	if(!NXWriteDefault([NXApp appName], "lastNumDialed", 
												[phoneNumField stringValue]))
		NXRunAlertPanel(0, "Error setting defaults database", 0, 0, 0);
	[gateToolProxy enScript:strcat(dialStr, " ")];
    [theInspector inspectName:"SecondInspector"];		// swap inspectors

    return self;
}
//*****************************************************************************
//
// 		send to the gatetool server quit tip instruction 
//
//*****************************************************************************

- tipQuit:sender  
{
	[gateToolProxy enScript:"PASS ~. "];

    return self;
}
//*****************************************************************************
//
// 		send to the gatetool server quit tip instruction 
//
//*****************************************************************************

- hangUp:sender  
{
char prefix[16] = {"PASS "}, minBuffer[3] = {"b "}, dialStr[16];
	
	minBuffer[0] = CEOF;
	strcpy(dialStr, prefix);
	[gateToolProxy enScript:strcat(dialStr, minBuffer)];
    [theInspector inspectName:"FirstInspector"];		// swap inspectors

    return self;
}
//*****************************************************************************
//
// 		quit tip and launch pppd so that it can attach to serial port 
//
//*****************************************************************************

- Attach:sender  
{
	[gateToolProxy enScript:"PASS ~. "];
	[delegate app:self openFile:NULL type:NULL];	
	connecting = YES;								// pppd will be started

    return self;
}
//*****************************************************************************
//
// 		self activate 
//
//*****************************************************************************

- activateGateKeeper  
{
NXConnection *	myConnection;

	[NXApp activateSelf:YES];
	gateToolProxy = [NXConnection connectToName:"GateToolServer"];
	if(gateToolProxy)			// use a protocol for DO efficiency 
		{
		[gateToolProxy setProtocolForProxy:@protocol(serverProtocol)];
				// return local NXconnection so that we can register for 	
				// invalidation of the proxy's port
		myConnection = [gateToolProxy connectionForProxy];
		[myConnection registerForInvalidationNotification:self];
		}

    return self;
}
//*****************************************************************************
//
// 		return name of tip Host (must be in /etc/remote) to use in manual Dial 
//
//*****************************************************************************

- (const char *)tipHost  
{
    return NXGetDefaultValue([NXApp appName], "tipHost");
}
//*****************************************************************************
//
// 		return name of modem initialization file to use in manual Dial 
//
//*****************************************************************************

- (const char *)modemInit  
{
	if(![[NXBundle mainBundle] getPath:Path forResource:flist[9] ofType:NULL])
		NXRunAlertPanel(0, "Error getting mainbundle path", 0, 0, 0);

    return Path;
}

- setDelegate:anObject
{
    delegate = anObject;
	
    return self;
}

- free:sender
{
	if(gatePanel)
		{
		[gatePanel close];
		[gatePanel free];
		}

    return [super free];
}

@end

