//************************************************************************
//
//	Preferences.m.  
//
//	by	Felipe A. Rodriguez		
//
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import "Preferences.h"
#import "SwapView.h"

		// used in creating a FIFO
	typedef unsigned short mode_t;
int mkfifo (const char *path, mode_t mode);

@interface Preferences(Private)

		// preferences popUpList titles 
	static char *titles[] = {"defaults", "Editor", NULL};	


@end
@implementation Preferences

//************************************************************************
//
//		sent to us after nib objects are unarchived and init'd 
//
//************************************************************************
 
- awakeFromNib
{
int i = 0;

	[swapView initPopUp:titles];
						// remem loc/size
	[[swapView window] setFrameAutosaveName:[[swapView window] title]]; 
	do  {		// if set in ddb turn check switch on
		if(strcmp(NXGetDefaultValue([NXApp appName], sList[i]), "YES") == 0)		
			[[swMatrix findCellWithTag:i] setIntValue:1];
		}
	while(sList[++i]);
	[self setControlForm:self];					// set control form strings
	[self setPPPForm:radioButtons];				// set ppp form strings
	[self timeout:self];				// set timeout circ slide/text field
		
    return self;
}
//************************************************************************
//
//		show pppEditor 
//
//************************************************************************

- show_pppEditor:sender 
{
	[self setPPPForm:radioButtons];				// set ppp form strings

    return self;
}
//***************************** Editor subview ***************************
//************************************************************************
//
//		 Edit ppp file button was pressed, open radio sel'd file in edit
//
//************************************************************************
 
- pppFileEdit:sender 
{
						// call edit to open radioButtons selected file 
	[[Application workspace] openFile:[self pathOf:
					(int)[radioButtons selectedTag]] withApplication:"Edit"];
	
    return self;
}
//************************************************************************
//
//		 Edit example ppp file button was pressed, in Editor subview.
//
//************************************************************************

- pppExampleEdit:sender 
{						// appWrapper is mainBundle, return path to resources
						// bundled within				 
    if(![[NXBundle mainBundle]getPath:Path forResource:"Examples" ofType:NULL])
		NXRunAlertPanel(0, "Error getting mainbundle path", 0, 0, 0);
	strcat(Path, exlist[(int)[radioButtons selectedTag]]);				
					// call edit to open file
	[[Application workspace] openFile:Path withApplication:"Edit"];
	
    return self;
}
//************************************************************************
//
//		send formcell a path based on the tag of the selected radio button.
//
//************************************************************************

- setPPPForm:sender
{
	[pppForm setStringValue:[self pathOf:(int)[sender selectedTag]] at:0];	
	if((3 < (int)[sender selectedTag]))
		[pppForm setEnabled:NO];  	
	else 
		[pppForm setEnabled:YES];

    return self;
}
//************************************************************************
//
//		 return the path of the item selected in flist[]
//
//************************************************************************

- (char *)pathOf:(int)i 
{
	if((i == 9) || (i == 10))	// Linkoptions/modemInit files in mainbundle
		{
		if(![[NXBundle mainBundle] getPath:Path forResource:flist[i] 
																ofType:NULL])
			NXRunAlertPanel(0, "Error getting mainbundle path", 0, 0, 0);
		}
	else
		strcpy(Path, NXGetDefaultValue([NXApp appName], flist[i]));
	
    return Path;
}
//***************************** defaults subview *************************
//************************************************************************
//
//		user has changed the path of one of the ppp files.
//
//************************************************************************

- pppFilesPathChanged:sender
{									// write an entry to defaults database
	if(!NXWriteDefault([NXApp appName], flist[(int)[radioButtons selectedTag]], 
								[sender stringValueAt:[sender selectedIndex]]))
		NXRunAlertPanel(0, "Error setting defaults database", 0, 0, 0);

    return self;
}
//************************************************************************
//
//		display ddb settings in string formcell array.
//
//************************************************************************

- setControlForm:sender
{
int i = 0;

	do  {
		[CSForm setStringValue:NXGetDefaultValue([NXApp appName],
															cList[i]) at:i];	
		}
	while(cList[++i]);

    return self;
}
//************************************************************************
//
//		user has changed a control string, store change in ddb
//
//************************************************************************
 
- CSFormChanged:sender
{
int i = (int)[sender selectedIndex];

				// write an entry to defaults database
	if(!NXWriteDefault([NXApp appName], cList[i], [sender stringValueAt:i]))
		NXRunAlertPanel(0, "Error setting defaults database", 0, 0, 0);
	if(i == 9)		// tip host has been changed, update our port ddb variable
		[[NXApp delegate] port];

    return self;
}
//************************************************************************
//
//		This fucntion toggles defaults db entries for our preferences
//		check switches based on the tag assigned in IB to each switch.
//
//************************************************************************

- switch:sender
{
int tag = [sender selectedTag];
										// toggles entries YES/NO
	if(strcmp(NXGetDefaultValue([NXApp appName], sList[tag]),"NO") == 0)
		{			// write an entry to defaults database
 		if(!NXWriteDefault([NXApp appName], sList[tag], "YES"))
			NXRunAlertPanel(0, "Error setting defaults database", 0, 0, 0);
		else 
			{
			if(tag == 0)				// Display Diagnostics was toggled
				{						// find FIFO path per /etc/syslog.conf
				[[NXApp delegate] fifo];	
											// remove FIFO and then remake it
				unlink(NXGetDefaultValue([NXApp appName],"locFIFO"));		
				mkfifo(NXGetDefaultValue([NXApp appName], "locFIFO"), 
																(mode_t) 644);
				strcpy(Path, "FIFO created at ");				
				strcat(Path, NXGetDefaultValue([NXApp appName], "locFIFO"));
				[[NXApp delegate] syslogdRun];			// restart syslogd
				NXRunAlertPanel(0, Path, 0, 0, 0);
				}
			if(tag == 9)				// Dial on Demand was enabled
				[[NXApp delegate] DialOnDemand];		// prepare for dial on 
			}
		}
	else 
		{
		if(tag == 9)			// Dial on Demand was disabled, revert to
			[[NXApp delegate] namedReset:"/usr/etc/named"];		// system named
		if(!NXWriteDefault([NXApp appName], sList[tag], "NO"))
			NXRunAlertPanel(0, "Error setting defaults database", 0, 0, 0);	
		}

    return self;
}
//*****************************************************************************
//
// 		target of timeout circular slider 
//
//*****************************************************************************

- timeout:sender
{
int i;

	if(sender == self) 							// if initial display of pref
		{
		i = atoi(NXGetDefaultValue([NXApp appName], "Timeout"));
		[timeoutCircSlider setIntValue:i];
		}
	else										// else user changed control
		{
		i = [sender intValue];
		[[NXApp delegate] setTimeout:i];		// set timeout in Coordinator
		}
	if(i == 0)
		[timeoutField setStringValue:"Off"];
	else
		[timeoutField setIntValue:i];

    return self;
}
//*********************** text field matrix delegation ************************
//*****************************************************************************
//
// 		as text delegate we recieve this when textfield cell is being edited 
//
//*****************************************************************************

- (BOOL)textWillChange:textObject
{
	[[swapView window] setDocEdited:YES];	// indicate change is not saved

    return NO;
}
//*****************************************************************************
//
// 		text delegate receives when editing of textfield cell is ended 
//
//*****************************************************************************

- textDidEnd:textObject endChar:(unsigned short)whyEnd
{
    if ((whyEnd == 16) || (whyEnd == 17)) 
		{
		[[swapView window] setDocEdited:NO];	// indicate change is saved
		}

    return self;
}

@end

//*****************************************************************************
//
// 		create FIFO at designated path with mode set to 
//
//*****************************************************************************

int mkfifo (const char *path, mode_t mode)
{
	return mknod (path, mode | S_IFIFO, 0);
}
