//************************************************************************
//
//	Some of this code is from the Coordinator object.  
//	Numerous additions, deletions, changes and any bugs courtesy of:
//
//		Felipe A. Rodriguez		
//
//	Portions of this file were derived from:
//	
//			Coordinator.m
//			by Joe Freeman, David LaVallee
//			Subprocess Example, Release 2.0
//			NeXT Computer, Inc.
//
//	This code is supplied "as is" the author makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//************************************************************************

#import <objc/Object.h>
#import <appkit/Application.h>
#import <appkit/nextstd.h>


@interface Coordinator:Object
{
	id  theIconView;
	id  imageList;			// list of ptr's to our active but not linked anim
	id  onImage;			// pointer to our "linked" tiff
	NXRect bRect;
	id  timeCell;
    id	commandView;
    id	gateMWin;
    id	link;
    id	unlink;
    id	dial;
    id  infoPanel;			/* The Info... panel */
    id  helpPanel;			/* outlet to our help panel */
    id  prefPanel;			/* The Preferences panel */
	id	theSavePanel; 
	id	theOpenPanel;   
	id	theSubprocess;
    id	stringTable;
	id  theTimer;
	id  theOpenButton;
	id  theOptionsEditor;
	BOOL userWantsTermination;	// subprocess fail should not kill GateKeeper
	BOOL acceptAnother;			// app can only have one doc open,is this case?
	char lastCall[MAXPATHLEN + 1];	 // stores path of last .Gate doc invoked
	BOOL openGate;				// animate should do open gate icon sequence
	BOOL standbyGate;			// animate should do open standby icon seq
	id theGateServer;			// distributed objects server
	id GateConnection;			// distributed objects server
	char Path[MAXPATHLEN + 1];	// generic buffer to hold paths
	time_t ltime;				// time used in producing a startup delay
	int numEntries[10];
	id  strHashTable;			// keywords hashtable used in detecting link up
	id  toolBar;				// our tool bar 
    char *capturedStr[4];		// ptr array to address str's and baud str
	id  iTimer;					// the Inacitivity Timer/pppstats controller 
	id  Parser;					// pattern search object
	int linkStg;				// stage of ppp link
}

- showInfo:sender;
- preferences:sender;
- showHelpPanel:sender;
- showTimerPanel:sender; 

- Dial:sender;  
- DOFinished;
- Link:sender;  
- UnLink:sender;  
- openDoc:sender;
- editDoc:sender;
- editGateDoc:(const char *)aGateDoc;
- newDoc:sender;
- addDefaultFiles:(const char *)nameOfFile;
- (BOOL)appAcceptsAnotherFile:sender; 
- showMenuTimer:(char *)buffer; 
- removeTimedEntry;
- gotIt;
- displayLinkStatus;
- analyzeBuffer:(char *)buffer;
- syslogdReset;
- syslogdRun;
- DialOnDemand;
- namedReset:(const char *)buffer;
- namedDod;
- fifo;
- port;
- toolBar:sender;
- setTimeout:(int)minTillTimeout; 
- readable:(const char *)nameOfFile;
- optionsEditor;
- appIconView;
- (BOOL)mailInQueue; 
- runScript:(const char *)type;  
- openMainWin;

	// Subprocess Delegation
- subprocessOutput:(char *)buffer;
- subprocessDone;
- subprocessError:(const char *)errorString;

	// Application Object Delegation
- appDidInit:sender;
- appWillTerminate:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type; 

	// Window Object Delegation
- windowWillMiniaturize:sender toMiniwindow:miniwindow; 

@end

