//*****************************************************************************
//
//
//	PrefSwapView.m.  
//
//		Subclass of SwapView for use in preferences
//
//	This code is supplied "as is" the author's makes no warranty as to its 
//	suitability for any purpose.  This code is free and may be distributed 
//	in accordance with the terms of the:
//		
//			GNU GENERAL PUBLIC LICENSE
//			Version 2, June 1991
//			copyright (C) 1989, 1991 Free Software Foundation, Inc.
// 			675 Mass Ave, Cambridge, MA 02139, USA
//
//*****************************************************************************


#import "PrefSwapView.h"
#import "OptionsEditor.h"
#import "Coordinator.h"

@implementation PrefSwapView

//*****************************************************************************
//
// 		This should return the id of a panel, which is off screen, and 
//		buffered, but not defered (SwapView needs its gstate).  SwapView will 
//		take the contentView of the panel and swap it in while also removing 
//		the old view, if any, and placing it back into its old panel.
//
//	 WARNING!!!!
//	Don't forget to make sure that the off screen windows are NOT deferred!!!
//	This means make sure that you turn the Deffered switch OFF in IB when
//	looking at the Atributes inspector.  This allows offscreen drawing.  
//	If it was on, then the gstate will be zero!!!!
//
// 		Ideally::  these panels should all be nibs so they have controllers
//				   and the above code should load the nib section if it
//				   already isn't loaded.  It should load here because you only
//				   want to take up memory when it is demanded. 
//
//*****************************************************************************

- whatPanel
{
	if(theTitle) 		// find out what panel to give to the SwapView
		{
		if (!strcmp(theTitle,"FirstInspector"))			// for use by swapViews
			return inspector = firstInspectorPanel;		// w/o a popUpList
		
		if (!strcmp(theTitle,"SecondInspector"))		// for use by swapViews
			return inspector = secondInspectorPanel;	// w/o a popUpList

		switch([popup indexOfItem:theTitle])
			{
			case 0:
				inspector = firstInspectorPanel;
				break;
				
			case 1:  				
				inspector = secondInspectorPanel;
				break;

			case 2:  				
				inspector = thirdInspectorPanel;
				break;

			case 3:  				
				inspector = fourthInspectorPanel;
				break;

			case 4: 
				if(!fifthInspectorPanel)
					{
					fifthInspectorPanel = [NXApp loadNibSection: 	
									"LinkEditor.nib" owner:self withNames:NO];
					if(!strcpy(Path, [[NXBundle mainBundle] directory]))
						NXRunAlertPanel(0,"Error getting mainbundle path:waPan"
																	, 0, 0, 0);
					else
						{
						strcat(Path, "/options");	// file name inside of dir
						[theOptionsEditor parseOptionsFile:Path];
						}
					}
				inspector = fifthInspectorPanel;
				break;

			case 5: 
				inspector = sixthInspectorPanel;
				break;
			}
		return inspector;
		}
								// the button title has no related inspector, 
	return (id)NULL;			// this should never happen.	
}


@end
